ClassIntrospector (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map

## Class ClassIntrospector<T extends BeanDescription>

- java.lang.Object
- - org.codehaus.jackson.map.ClassIntrospector<T>

- Direct Known Subclasses:
    BasicClassIntrospector

      public abstract class ClassIntrospector<T extends BeanDescription>
      extends Object

  Helper class used to introspect features of POJO value classes used with Jackson. The main use is for finding out POJO construction (creator) and value access (getters, setters) methods and annotations that define configuration of using those methods.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `ClassIntrospector.MixInResolver` Interface used for decoupling details of how mix-in annotation definitions are accessed (via this interface), and how they are stored (defined by classes that implement the interface)

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ClassIntrospector()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `T` | `forClassAnnotations(MapperConfig<?> cfg, Class<?> cls, ClassIntrospector.MixInResolver r)` Deprecated. since 1.9, use variant that takes JavaType
    `abstract T` | `forClassAnnotations(MapperConfig<?> cfg, JavaType type, ClassIntrospector.MixInResolver r)` Factory method that constructs an introspector that only has information regarding annotations class itself (or its supertypes) has, but nothing on methods or constructors.
    `abstract T` | `forCreation(DeserializationConfig cfg, JavaType type, ClassIntrospector.MixInResolver r)` Factory method that constructs an introspector that has information necessary for creating instances of given class ("creator"), as well as class annotations, but no information on member methods
    `abstract T` | `forDeserialization(DeserializationConfig cfg, JavaType type, ClassIntrospector.MixInResolver r)` Factory method that constructs an introspector that has all information needed for deserialization purposes.
    `T` | `forDirectClassAnnotations(MapperConfig<?> cfg, Class<?> cls, ClassIntrospector.MixInResolver r)` Deprecated. since 1.9, use variant that takes JavaType
    `abstract T` | `forDirectClassAnnotations(MapperConfig<?> cfg, JavaType type, ClassIntrospector.MixInResolver r)` Factory method that constructs an introspector that only has information regarding annotations class itself has (but NOT including its supertypes), but nothing on methods or constructors.
    `abstract T` | `forSerialization(SerializationConfig cfg, JavaType type, ClassIntrospector.MixInResolver r)` Factory method that constructs an introspector that has all information needed for serialization purposes.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ClassIntrospector

          protected ClassIntrospector()

  - ### Method Detail

    - #### forSerialization

          public abstract T forSerialization(SerializationConfig cfg,
                           JavaType type,
                           ClassIntrospector.MixInResolver r)

      Factory method that constructs an introspector that has all information needed for serialization purposes.

    - #### forDeserialization

          public abstract T forDeserialization(DeserializationConfig cfg,
                             JavaType type,
                             ClassIntrospector.MixInResolver r)

      Factory method that constructs an introspector that has all information needed for deserialization purposes.

    - #### forCreation

          public abstract T forCreation(DeserializationConfig cfg,
                      JavaType type,
                      ClassIntrospector.MixInResolver r)

      Factory method that constructs an introspector that has information necessary for creating instances of given class ("creator"), as well as class annotations, but no information on member methods

    - #### forClassAnnotations

          public abstract T forClassAnnotations(MapperConfig<?> cfg,
                              JavaType type,
                              ClassIntrospector.MixInResolver r)

      Factory method that constructs an introspector that only has information regarding annotations class itself (or its supertypes) has, but nothing on methods or constructors.

    - #### forDirectClassAnnotations

          public abstract T forDirectClassAnnotations(MapperConfig<?> cfg,
                                    JavaType type,
                                    ClassIntrospector.MixInResolver r)

      Factory method that constructs an introspector that only has information regarding annotations class itself has (but NOT including its supertypes), but nothing on methods or constructors.
      Since:
        1.5

    - #### forClassAnnotations

          @Deprecated
          public T forClassAnnotations(MapperConfig<?> cfg,
                                         Class<?> cls,
                                         ClassIntrospector.MixInResolver r)

      Deprecated. since 1.9, use variant that takes JavaType
      Factory method that constructs an introspector that only has information regarding annotations class itself (or its supertypes) has, but nothing on methods or constructors.

    - #### forDirectClassAnnotations

          @Deprecated
          public T forDirectClassAnnotations(MapperConfig<?> cfg,
                                               Class<?> cls,
                                               ClassIntrospector.MixInResolver r)

      Deprecated. since 1.9, use variant that takes JavaType
      Factory method that constructs an introspector that only has information regarding annotations class itself has (but NOT including its supertypes), but nothing on methods or constructors.
      Since:
        1.5